diff --git a/src/components/agents/agent-action-row.tsx b/src/components/agents/agent-action-row.tsx
new file mode 100644
index 0000000..39b3a48
--- /dev/null
+++ b/src/components/agents/agent-action-row.tsx
@@ -0,0 +1,83 @@
+// src/components/agents/agent-action-row.tsx
+'use client';
+
+import { AgentAssignButton } from './agent-assign-button';
+import { AgentSpawnButton } from './agent-spawn-button';
+import { useAgentStatus, useSpawnAgent } from './hooks';
+import type { AgentArchetype } from '../../lib/types-swarm';
+
+export interface AgentActionRowProps {
+  beadId: string;
+  beadStatus: string;
+  agents: AgentArchetype[];
+  projectRoot: string;
+  currentAgentTypeId?: string;
+  onAgentAssigned?: (agentTypeId: string) => void;
+  onAgentSpawned?: (workerId: string, displayName: string) => void;
+  size?: 'sm' | 'md';
+}
+
+export function AgentActionRow({
+  beadId,
+  beadStatus,
+  agents,
+  projectRoot,
+  currentAgentTypeId,
+  onAgentAssigned,
+  onAgentSpawned,
+  size = 'sm',
+}: AgentActionRowProps) {
+  const { workerStatus, workerDisplayName, workerError } = useAgentStatus(beadId);
+  const { spawn, isSpawning } = useSpawnAgent(projectRoot);
+
+  const handleAssign = async (agentTypeId: string) => {
+    // Call API to assign agent type to bead
+    try {
+      const response = await fetch('/api/beads/assign-agent', {
+        method: 'POST',
+        headers: { 'Content-Type': 'application/json' },
+        body: JSON.stringify({ beadId, agentTypeId }),
+      });
+      if (response.ok && onAgentAssigned) {
+        onAgentAssigned(agentTypeId);
+      }
+    } catch (error) {
+      console.error('Failed to assign agent:', error);
+    }
+  };
+
+  const handleSpawn = async () => {
+    if (!currentAgentTypeId) return;
+    
+    const result = await spawn(beadId, currentAgentTypeId);
+    if (result.success && onAgentSpawned) {
+      onAgentSpawned(result.workerId!, result.displayName!);
+    }
+  };
+
+  // Don't show for closed beads
+  if (beadStatus === 'closed') {
+    return null;
+  }
+
+  return (
+    <div className="flex items-center gap-1.5">
+      <AgentAssignButton
+        beadId={beadId}
+        agents={agents}
+        currentAgentTypeId={currentAgentTypeId}
+        onAssign={handleAssign}
+        size={size}
+      />
+      <AgentSpawnButton
+        beadId={beadId}
+        agentTypeId={currentAgentTypeId}
+        workerStatus={isSpawning ? 'spawning' : workerStatus}
+        workerDisplayName={workerDisplayName}
+        workerError={workerError}
+        onSpawn={handleSpawn}
+        size={size}
+      />
+    </div>
+  );
+}
diff --git a/src/components/agents/agent-assign-button.tsx b/src/components/agents/agent-assign-button.tsx
new file mode 100644
index 0000000..f468386
--- /dev/null
+++ b/src/components/agents/agent-assign-button.tsx
@@ -0,0 +1,79 @@
+// src/components/agents/agent-assign-button.tsx
+'use client';
+
+import { useState } from 'react';
+import { UserPlus } from 'lucide-react';
+import { AgentPickerPopup } from './agent-picker-popup';
+import type { AgentArchetype } from '../../lib/types-swarm';
+
+export interface AgentAssignButtonProps {
+  beadId: string;
+  agents: AgentArchetype[];
+  currentAgentTypeId?: string;
+  onAssign: (agentTypeId: string) => void;
+  size?: 'sm' | 'md';
+  disabled?: boolean;
+}
+
+export function AgentAssignButton({
+  beadId,
+  agents,
+  currentAgentTypeId,
+  onAssign,
+  size = 'sm',
+  disabled = false,
+}: AgentAssignButtonProps) {
+  const [isOpen, setIsOpen] = useState(false);
+
+  const sizeClasses = size === 'sm' 
+    ? 'h-6 w-6' 
+    : 'h-7 w-7';
+
+  const iconSize = size === 'sm' 
+    ? 'w-3 h-3' 
+    : 'w-3.5 h-3.5';
+
+  const isAssigned = !!currentAgentTypeId;
+  const assignedAgent = agents.find(a => a.id === currentAgentTypeId);
+  const bgColor = isAssigned && assignedAgent 
+    ? `${assignedAgent.color}30` 
+    : 'var(--surface-tertiary)';
+  const iconColor = isAssigned && assignedAgent 
+    ? assignedAgent.color 
+    : 'var(--text-tertiary)';
+
+  return (
+    <div className="relative">
+      <button
+        type="button"
+        onClick={() => !disabled && setIsOpen(true)}
+        disabled={disabled}
+        className={`inline-flex ${sizeClasses} items-center justify-center rounded-md border transition-colors ${
+          disabled 
+            ? 'opacity-50 cursor-not-allowed' 
+            : 'hover:opacity-80'
+        }`}
+        style={{
+          backgroundColor: bgColor,
+          borderColor: isAssigned && assignedAgent 
+            ? `${assignedAgent.color}50` 
+            : 'var(--border-subtle)',
+        }}
+        title={isAssigned ? `Assigned: ${assignedAgent?.name}` : 'Assign agent'}
+      >
+        <UserPlus className={iconSize} style={{ color: iconColor }} />
+      </button>
+
+      <AgentPickerPopup
+        isOpen={isOpen}
+        onClose={() => setIsOpen(false)}
+        agents={agents}
+        selectedAgentId={currentAgentTypeId}
+        onSelect={(agentId) => {
+          onAssign(agentId);
+          setIsOpen(false);
+        }}
+      />
+    </div>
+  );
+}
diff --git a/src/components/agents/agent-picker-popup.tsx b/src/components/agents/agent-picker-popup.tsx
new file mode 100644
index 0000000..28f79f5
--- /dev/null
+++ b/src/components/agents/agent-picker-popup.tsx
@@ -0,0 +1,120 @@
+// src/components/agents/agent-picker-popup.tsx
+'use client';
+
+import { useEffect, useRef } from 'react';
+import { Rocket, Brain, Wrench, Search, CheckCircle, FlaskConical, Upload } from 'lucide-react';
+import type { AgentArchetype } from '../../lib/types-swarm';
+
+export interface AgentPickerPopupProps {
+  isOpen: boolean;
+  onClose: () => void;
+  agents: AgentArchetype[];
+  selectedAgentId?: string;
+  onSelect: (agentId: string) => void;
+  onSpawn?: (agentId: string) => void;
+  position?: { x: number; y: number };
+}
+
+const AGENT_ICONS: Record<string, React.ReactNode> = {
+  architect: <Brain className="w-4 h-4" />,
+  engineer: <Wrench className="w-4 h-4" />,
+  investigator: <Search className="w-4 h-4" />,
+  reviewer: <CheckCircle className="w-4 h-4" />,
+  tester: <FlaskConical className="w-4 h-4" />,
+  shipper: <Upload className="w-4 h-4" />,
+};
+
+export function AgentPickerPopup({
+  isOpen,
+  onClose,
+  agents,
+  selectedAgentId,
+  onSelect,
+  onSpawn,
+  position,
+}: AgentPickerPopupProps) {
+  const ref = useRef<HTMLDivElement>(null);
+
+  useEffect(() => {
+    const handleClickOutside = (e: MouseEvent) => {
+      if (ref.current && !ref.current.contains(e.target as Node)) {
+        onClose();
+      }
+    };
+    if (isOpen) {
+      document.addEventListener('mousedown', handleClickOutside);
+    }
+    return () => document.removeEventListener('mousedown', handleClickOutside);
+  }, [isOpen, onClose]);
+
+  if (!isOpen) return null;
+
+  const style = position
+    ? { position: 'absolute' as const, left: position.x, top: position.y + 8 }
+    : {};
+
+  return (
+    <div
+      ref={ref}
+      style={style}
+      className="z-50 min-w-[180px] rounded-lg border border-[var(--border-subtle)] bg-[var(--surface-elevated)] p-1 shadow-lg"
+    >
+      {/* Orchestrator option */}
+      <button
+        onClick={() => {
+          onSelect('orchestrator');
+          onClose();
+        }}
+        className={`flex w-full items-center gap-2 rounded-md px-3 py-2 text-left text-sm transition-colors ${
+          selectedAgentId === 'orchestrator'
+            ? 'bg-[var(--accent-info)]/20 text-[var(--accent-info)]'
+            : 'text-[var(--text-primary)] hover:bg-[var(--surface-hover)]'
+        }`}
+      >
+        <Rocket className="w-4 h-4" />
+        <span className="font-medium">Orchestrator</span>
+        <span className="ml-auto text-xs text-[var(--text-tertiary)]">auto</span>
+      </button>
+
+      <div className="my-1 border-t border-[var(--border-subtle)]" />
+
+      {/* Agent types */}
+      {agents.map((agent) => (
+        <button
+          key={agent.id}
+          onClick={() => {
+            onSelect(agent.id);
+            onClose();
+          }}
+          className={`flex w-full items-center gap-2 rounded-md px-3 py-2 text-left text-sm transition-colors ${
+            selectedAgentId === agent.id
+              ? 'bg-[var(--accent-info)]/20 text-[var(--accent-info)]'
+              : 'text-[var(--text-primary)] hover:bg-[var(--surface-hover)]'
+          }`}
+        >
+          <span style={{ color: agent.color }}>
+            {AGENT_ICONS[agent.id] || <Wrench className="w-4 h-4" />}
+          </span>
+          <span>{agent.name}</span>
+        </button>
+      ))}
+
+      {/* Spawn button */}
+      {onSpawn && selectedAgentId && (
+        <>
+          <div className="my-1 border-t border-[var(--border-subtle)]" />
+          <button
+            onClick={() => {
+              onSpawn(selectedAgentId);
+              onClose();
+            }}
+            className="flex w-full items-center justify-center gap-2 rounded-md bg-emerald-500/20 px-3 py-2 text-sm font-medium text-emerald-400 transition-colors hover:bg-emerald-500/30"
+          >
+            <Rocket className="w-4 h-4" />
+            Spawn {agents.find(a => a.id === selectedAgentId)?.name || 'Agent'}
+          </button>
+        </>
+      )}
+    </div>
+  );
+}
diff --git a/src/components/agents/agent-spawn-button.tsx b/src/components/agents/agent-spawn-button.tsx
new file mode 100644
index 0000000..1e57ce3
--- /dev/null
+++ b/src/components/agents/agent-spawn-button.tsx
@@ -0,0 +1,132 @@
+// src/components/agents/agent-spawn-button.tsx
+'use client';
+
+import { Rocket, CheckCircle, AlertCircle, Loader2 } from 'lucide-react';
+import type { WorkerStatus } from './hooks/use-agent-status';
+
+export interface AgentSpawnButtonProps {
+  beadId: string;
+  agentTypeId?: string;
+  workerStatus: WorkerStatus;
+  workerDisplayName?: string;
+  workerError?: string;
+  onSpawn: () => void;
+  size?: 'sm' | 'md';
+  disabled?: boolean;
+}
+
+const STATUS_CONFIG: Record<WorkerStatus, {
+  icon: React.ReactNode;
+  color: string;
+  bgColor: string;
+  borderColor: string;
+  title: string;
+  pulsing?: boolean;
+}> = {
+  idle: {
+    icon: <Rocket className="w-3 h-3" />,
+    color: '#6b7280',
+    bgColor: 'rgba(107, 114, 128, 0.1)',
+    borderColor: 'rgba(107, 114, 128, 0.3)',
+    title: 'No agent assigned',
+  },
+  spawning: {
+    icon: <Loader2 className="w-3 h-3 animate-spin" />,
+    color: '#3b82f6',
+    bgColor: 'rgba(59, 130, 246, 0.1)',
+    borderColor: 'rgba(59, 130, 246, 0.3)',
+    title: 'Spawning...',
+    pulsing: true,
+  },
+  working: {
+    icon: <Rocket className="w-3 h-3" />,
+    color: '#22c55e',
+    bgColor: 'rgba(34, 197, 94, 0.1)',
+    borderColor: 'rgba(34, 197, 94, 0.3)',
+    title: 'Working',
+    pulsing: true,
+  },
+  blocked: {
+    icon: <AlertCircle className="w-3 h-3" />,
+    color: '#ef4444',
+    bgColor: 'rgba(239, 68, 68, 0.1)',
+    borderColor: 'rgba(239, 68, 68, 0.3)',
+    title: 'Blocked',
+  },
+  completed: {
+    icon: <CheckCircle className="w-3 h-3" />,
+    color: '#22c55e',
+    bgColor: 'rgba(34, 197, 94, 0.1)',
+    borderColor: 'rgba(34, 197, 94, 0.3)',
+    title: 'Completed',
+  },
+  failed: {
+    icon: <AlertCircle className="w-3 h-3" />,
+    color: '#ef4444',
+    bgColor: 'rgba(239, 68, 68, 0.1)',
+    borderColor: 'rgba(239, 68, 68, 0.3)',
+    title: 'Failed',
+  },
+};
+
+export function AgentSpawnButton({
+  beadId,
+  agentTypeId,
+  workerStatus,
+  workerDisplayName,
+  workerError,
+  onSpawn,
+  size = 'sm',
+  disabled = false,
+}: AgentSpawnButtonProps) {
+  const config = STATUS_CONFIG[workerStatus];
+  const sizeClasses = size === 'sm' ? 'h-6 w-6' : 'h-7 w-7';
+  
+  // No agent assigned - don't show button
+  if (!agentTypeId && workerStatus === 'idle') {
+    return null;
+  }
+
+  const canSpawn = workerStatus === 'idle' && agentTypeId;
+  const showTooltip = workerStatus === 'working' || workerStatus === 'blocked' || workerStatus === 'completed';
+
+  return (
+    <div className="relative group">
+      <button
+        type="button"
+        onClick={() => canSpawn && !disabled && onSpawn()}
+        disabled={disabled || !canSpawn}
+        className={`inline-flex ${sizeClasses} items-center justify-center rounded-md border transition-colors ${
+          disabled || !canSpawn ? 'cursor-default' : 'hover:opacity-80'
+        } ${config.pulsing ? 'animate-pulse' : ''}`}
+        style={{
+          backgroundColor: config.bgColor,
+          borderColor: config.borderColor,
+          color: config.color,
+        }}
+        title={workerDisplayName ? `${config.title}: ${workerDisplayName}` : config.title}
+      >
+        {config.icon}
+      </button>
+
+      {/* Tooltip for active workers */}
+      {showTooltip && (
+        <div className="absolute bottom-full left-1/2 -translate-x-1/2 mb-2 hidden group-hover:block z-50">
+          <div className="rounded-md bg-[var(--surface-elevated)] border border-[var(--border-subtle)] px-3 py-2 shadow-lg min-w-[160px]">
+            <p className="text-xs font-medium text-[var(--text-primary)]">
+              {workerDisplayName || 'Agent'}
+            </p>
+            <p className="text-[10px] text-[var(--text-tertiary)] capitalize">
+              {workerStatus}
+            </p>
+            {workerError && (
+              <p className="text-[10px] text-red-400 mt-1 truncate">
+                {workerError}
+              </p>
+            )}
+          </div>
+        </div>
+      )}
+    </div>
+  );
+}
diff --git a/src/components/agents/agent-status-panel.tsx b/src/components/agents/agent-status-panel.tsx
new file mode 100644
index 0000000..94baa0d
--- /dev/null
+++ b/src/components/agents/agent-status-panel.tsx
@@ -0,0 +1,158 @@
+'use client';
+
+import { useEffect, useState } from 'react';
+import type { AgentInstance, AgentStatus } from '../../lib/agent-instance';
+import { Activity, CheckCircle, XCircle, Loader2, Users } from 'lucide-react';
+
+interface AgentStatusPanelProps {
+  projectRoot: string;
+}
+
+export function AgentStatusPanel({ projectRoot }: AgentStatusPanelProps) {
+  const [status, setStatus] = useState<AgentStatus | null>(null);
+  const [history, setHistory] = useState<AgentInstance[]>([]);
+  const [loading, setLoading] = useState(true);
+
+  useEffect(() => {
+    // Poll for agent status updates
+    const poll = async () => {
+      try {
+        const [statusRes, historyRes] = await Promise.all([
+          fetch(`/api/runtime/agents?projectRoot=${encodeURIComponent(projectRoot)}`),
+          fetch(`/api/runtime/agents/history?projectRoot=${encodeURIComponent(projectRoot)}`),
+        ]);
+        const statusData = await statusRes.json();
+        const historyData = await historyRes.json();
+        
+        if (statusData.ok) setStatus(statusData.status);
+        if (historyData.ok) setHistory(historyData.instances);
+      } catch (error) {
+        console.error('Failed to fetch agent status:', error);
+      } finally {
+        setLoading(false);
+      }
+    };
+
+    poll();
+    const interval = setInterval(poll, 2000);
+    return () => clearInterval(interval);
+  }, [projectRoot]);
+
+  if (loading) {
+    return (
+      <div className="flex items-center justify-center py-8">
+        <Loader2 className="w-5 h-5 animate-spin text-[var(--text-tertiary)]" />
+      </div>
+    );
+  }
+
+  return (
+    <div className="space-y-4">
+      {/* Active Agents Section */}
+      <div>
+        <h3 className="text-xs font-semibold text-[var(--text-secondary)] uppercase tracking-wider mb-2 flex items-center gap-2">
+          <Activity className="w-3.5 h-3.5" />
+          Active Agents ({status?.totalActive || 0})
+        </h3>
+        
+        {!status || status.instances.length === 0 ? (
+          <p className="text-sm text-[var(--text-tertiary)] italic py-2">
+            No active agents. Spawn an agent to work on a task.
+          </p>
+        ) : (
+          <div className="space-y-2">
+            {status.instances.map(instance => (
+              <AgentInstanceCard key={instance.id} instance={instance} />
+            ))}
+          </div>
+        )}
+      </div>
+
+      {/* Recent Completions Section */}
+      {history.length > 0 && (
+        <div>
+          <h3 className="text-xs font-semibold text-[var(--text-secondary)] uppercase tracking-wider mb-2 flex items-center gap-2">
+            <Users className="w-3.5 h-3.5" />
+            Recent Completions
+          </h3>
+          <div className="space-y-1 max-h-40 overflow-auto">
+            {history.slice(0, 10).map(instance => (
+              <AgentHistoryItem key={instance.id} instance={instance} />
+            ))}
+          </div>
+        </div>
+      )}
+
+      {/* Summary by Type */}
+      {status && Object.keys(status.byType).length > 0 && (
+        <div className="pt-3 border-t border-[var(--border-subtle)]">
+          <div className="text-[10px] font-mono text-[var(--text-tertiary)] uppercase tracking-wider mb-2">
+            By Type
+          </div>
+          <div className="flex flex-wrap gap-2">
+            {Object.entries(status.byType).map(([type, count]) => (
+              <div
+                key={type}
+                className="px-2 py-1 rounded bg-[var(--surface-quaternary)] text-xs"
+              >
+                <span className="font-medium capitalize">{type}</span>
+                <span className="text-[var(--text-tertiary)] ml-1">{count}</span>
+              </div>
+            ))}
+          </div>
+        </div>
+      )}
+    </div>
+  );
+}
+
+function AgentInstanceCard({ instance }: { instance: AgentInstance }) {
+  const statusConfig = {
+    spawning: { color: 'bg-yellow-500', icon: Loader2, animate: true },
+    working: { color: 'bg-cyan-500', icon: Activity, animate: false },
+    idle: { color: 'bg-gray-500', icon: Activity, animate: false },
+    completed: { color: 'bg-green-500', icon: CheckCircle, animate: false },
+    failed: { color: 'bg-red-500', icon: XCircle, animate: false },
+  };
+
+  const config = statusConfig[instance.status];
+  const Icon = config.icon;
+
+  return (
+    <div className="flex items-center gap-3 p-2 rounded bg-[var(--surface-quaternary)] border border-[var(--border-subtle)]">
+      <div className={`w-2 h-2 rounded-full ${config.color}`} />
+      <div className="flex-1 min-w-0">
+        <div className="flex items-center gap-2">
+          <span className="text-sm font-medium">{instance.displayName}</span>
+          <span className="text-[10px] text-[var(--text-tertiary)] uppercase">
+            {instance.status}
+          </span>
+        </div>
+        {instance.currentBeadId && (
+          <div className="text-xs text-[var(--text-tertiary)] truncate">
+            → {instance.currentBeadId}
+          </div>
+        )}
+      </div>
+      <Icon className={`w-4 h-4 text-[var(--text-tertiary)] ${config.animate ? 'animate-spin' : ''}`} />
+    </div>
+  );
+}
+
+function AgentHistoryItem({ instance }: { instance: AgentInstance }) {
+  const isSuccess = instance.status === 'completed';
+  
+  return (
+    <div className="flex items-center gap-2 text-xs p-1.5 rounded bg-[var(--surface-tertiary)]">
+      {isSuccess ? (
+        <CheckCircle className="w-3 h-3 text-green-400" />
+      ) : (
+        <XCircle className="w-3 h-3 text-red-400" />
+      )}
+      <span className="font-medium">{instance.displayName}</span>
+      {instance.currentBeadId && (
+        <span className="text-[var(--text-tertiary)]">→ {instance.currentBeadId}</span>
+      )}
+    </div>
+  );
+}
diff --git a/src/components/agents/hooks/index.ts b/src/components/agents/hooks/index.ts
new file mode 100644
index 0000000..2677fcb
--- /dev/null
+++ b/src/components/agents/hooks/index.ts
@@ -0,0 +1,3 @@
+// src/components/agents/hooks/index.ts
+export { useAgentStatus, type AgentStatus, type WorkerStatus } from './use-agent-status';
+export { useSpawnAgent, type SpawnResult } from './use-spawn-agent';
diff --git a/src/components/agents/hooks/use-agent-status.ts b/src/components/agents/hooks/use-agent-status.ts
new file mode 100644
index 0000000..f32fde0
--- /dev/null
+++ b/src/components/agents/hooks/use-agent-status.ts
@@ -0,0 +1,68 @@
+// src/components/agents/hooks/use-agent-status.ts
+import { useState, useEffect, useRef } from 'react';
+
+export type WorkerStatus = 'idle' | 'spawning' | 'working' | 'blocked' | 'completed' | 'failed';
+
+export interface AgentStatus {
+  agentTypeId?: string;
+  workerStatus: WorkerStatus;
+  workerDisplayName?: string;
+  workerError?: string;
+  isLoading: boolean;
+}
+
+const POLL_INTERVAL_MS = 5000;
+
+export function useAgentStatus(beadId: string): AgentStatus {
+  const [status, setStatus] = useState<AgentStatus>({
+    workerStatus: 'idle',
+    isLoading: true,
+  });
+  const intervalRef = useRef<NodeJS.Timeout | null>(null);
+
+  const fetchStatus = async () => {
+    if (!beadId) return;
+    
+    try {
+      const response = await fetch(`/api/runtime/worker-status?beadId=${encodeURIComponent(beadId)}`);
+      if (!response.ok) {
+        // If API returns 404 or error, no worker exists yet
+        setStatus({ workerStatus: 'idle', isLoading: false });
+        return;
+      }
+      
+      const data = await response.json();
+      setStatus({
+        workerStatus: data.status || 'idle',
+        workerDisplayName: data.displayName,
+        workerError: data.error,
+        agentTypeId: data.agentTypeId,
+        isLoading: false,
+      });
+    } catch (error) {
+      console.error('Failed to fetch worker status:', error);
+      setStatus({ workerStatus: 'idle', isLoading: false });
+    }
+  };
+
+  useEffect(() => {
+    if (!beadId) {
+      setStatus({ workerStatus: 'idle', isLoading: false });
+      return;
+    }
+
+    // Initial fetch
+    fetchStatus();
+
+    // Set up polling
+    intervalRef.current = setInterval(fetchStatus, POLL_INTERVAL_MS);
+
+    return () => {
+      if (intervalRef.current) {
+        clearInterval(intervalRef.current);
+      }
+    };
+  }, [beadId]);
+
+  return status;
+}
diff --git a/src/components/agents/hooks/use-spawn-agent.ts b/src/components/agents/hooks/use-spawn-agent.ts
new file mode 100644
index 0000000..e4f4a51
--- /dev/null
+++ b/src/components/agents/hooks/use-spawn-agent.ts
@@ -0,0 +1,41 @@
+// src/components/agents/hooks/use-spawn-agent.ts
+import { useState } from 'react';
+
+export interface SpawnResult {
+  success: boolean;
+  workerId?: string;
+  displayName?: string;
+  error?: string;
+}
+
+export function useSpawnAgent(projectRoot: string) {
+  const [isSpawning, setIsSpawning] = useState(false);
+
+  const spawn = async (beadId: string, agentTypeId: string): Promise<SpawnResult> => {
+    setIsSpawning(true);
+    try {
+      const response = await fetch('/api/runtime/spawn', {
+        method: 'POST',
+        headers: { 'Content-Type': 'application/json' },
+        body: JSON.stringify({ projectRoot, beadId, agentTypeId }),
+      });
+      const data = await response.json();
+      
+      if (!data.ok) {
+        return { success: false, error: data.error };
+      }
+      
+      return {
+        success: true,
+        workerId: data.workerId,
+        displayName: data.displayName,
+      };
+    } catch (error) {
+      return { success: false, error: String(error) };
+    } finally {
+      setIsSpawning(false);
+    }
+  };
+
+  return { spawn, isSpawning };
+}
diff --git a/src/components/agents/index.ts b/src/components/agents/index.ts
new file mode 100644
index 0000000..cc8f339
--- /dev/null
+++ b/src/components/agents/index.ts
@@ -0,0 +1,6 @@
+// src/components/agents/index.ts
+export { AgentActionRow, type AgentActionRowProps } from './agent-action-row';
+export { AgentAssignButton, type AgentAssignButtonProps } from './agent-assign-button';
+export { AgentSpawnButton, type AgentSpawnButtonProps } from './agent-spawn-button';
+export { AgentPickerPopup, type AgentPickerPopupProps } from './agent-picker-popup';
+export * from './hooks';
diff --git a/src/components/graph/assignment-panel.tsx b/src/components/graph/assignment-panel.tsx
index 441e4e4..ef78544 100644
--- a/src/components/graph/assignment-panel.tsx
+++ b/src/components/graph/assignment-panel.tsx
@@ -2,9 +2,9 @@
 
 import React, { useState, useMemo } from 'react';
 import { Zap, Users, FileCode2, Loader2, UserPlus, Clock, AlertCircle, ChevronDown, ChevronRight, Blocks, Layers } from 'lucide-react';
-import { ArchetypeInspector } from '../swarm/archetype-inspector';
+import { AgentInspector } from '../swarm/agent-inspector';
 import { TemplateInspector } from '../swarm/template-inspector';
-import { ArchetypePicker } from '../swarm/archetype-picker';
+import { AgentPicker } from '../swarm/agent-picker';
 import { TemplatePicker } from '../swarm/template-picker';
 import { useArchetypes } from '../../hooks/use-archetypes';
 import { useTemplates } from '../../hooks/use-templates';
@@ -219,8 +219,8 @@ export function AssignmentPanel({ selectedIssue, projectRoot, issues, epicId, on
         });
     };
 
-    const getArchetypeCountInTeam = (template: SwarmTemplate, archetypeId: string): number => {
-        return template.team.filter(member => member.archetypeId === archetypeId).length;
+    const getArchetypeCountInTeam = (template: SwarmTemplate, agentTypeId: string): number => {
+        return template.team.filter(member => member.agentTypeId === agentTypeId).length;
     };
 
     const renderTaskItem = (issue: BeadIssue, showAssignButton: boolean = false, archetypeBadges: AgentArchetype[] = []) => (
@@ -290,7 +290,7 @@ export function AssignmentPanel({ selectedIssue, projectRoot, issues, epicId, on
                 </button>
             </div>
 
-            <ArchetypePicker
+            <AgentPicker
                 archetypes={archetypes}
                 isOpen={showArchetypeList}
                 onClose={() => setShowArchetypeList(false)}
@@ -361,12 +361,12 @@ export function AssignmentPanel({ selectedIssue, projectRoot, issues, epicId, on
                                     <div>
                                         <div className="text-[10px] font-mono text-[var(--text-tertiary)] uppercase tracking-wider mb-2">Team Roster</div>
                                         <div className="space-y-1">
-                                            {Array.from(new Set(epicTemplate.team.map(m => m.archetypeId))).map(archetypeId => {
-                                                const archetype = archetypes.find((a: AgentArchetype) => a.id === archetypeId);
-                                                const count = getArchetypeCountInTeam(epicTemplate, archetypeId);
+                                            {Array.from(new Set(epicTemplate.team.map(m => m.agentTypeId))).map(agentTypeId => {
+                                                const archetype = archetypes.find((a: AgentArchetype) => a.id === agentTypeId);
+                                                const count = getArchetypeCountInTeam(epicTemplate, agentTypeId);
                                                 if (!archetype) return null;
                                                 return (
-                                                    <div key={archetypeId} className="flex items-center gap-2 text-xs">
+                                                    <div key={agentTypeId} className="flex items-center gap-2 text-xs">
                                                         <div
                                                             className="h-4 w-4 rounded flex items-center justify-center text-[10px] font-bold"
                                                             style={{
@@ -557,7 +557,7 @@ export function AssignmentPanel({ selectedIssue, projectRoot, issues, epicId, on
             </div>
 
             {inspectingArchetypeId !== null && (
-                <ArchetypeInspector
+                <AgentInspector
                     archetype={archetypes.find((a: AgentArchetype) => a.id === inspectingArchetypeId)}
                     onClose={() => setInspectingArchetypeId(null)}
                     onSave={saveArchetype}
